/*

  OBI 2003
  Problema: Manutencao
  Autor : Rodrigo Schmidt

  Estrategia: Busca de pontos de articulacao em um 
  grafo nao dirigido conexo usando busca em profundidade simples.

  Complexidade de Tempo: O(n^2)

*/


#include <stdio.h>
#include <string.h>


int graph[400][400];  /* grafo */
char visited[400];    /* visitados */
int depth[400];       /* profundidade na arvore de busca de cada vertice */
int is_art[400];      /* vertice eh um ponto de articulacao?? */
int none;             /* "nenhum" deve ser impresso */

int n;

int dfs ( int v, int level)
{
  int i,low,k,is=0;

  visited[v] = 1;
  depth[v] = level;
  low = level;

  /* low representa a menor profundidade na arvore de busca alcancada pelo
     vertice ou seus filhos por arestas de retorno na arvore */

  for(i=0;i<n;i++)
    if (graph[v][i])
      {
	if (!visited[i])
	  {
	    if ((k=dfs(i,level+1)) >= level)
	      is++;
	    if( low > k )
	      low = k;
	  }
	else
	  if (low > depth[i])
	    low = depth[i];
      }

  is_art[v] = (level && is) || (!level && (is>1));
  /* vertice e articulacao se for raiz da busca e tiver mais do que um filho
     na arvore de busca ou se nao for a raiz e tiver um filho cuja menor
     profundidade alcancada por arestas de retorno seja maior ou igual que a
     profundidade do vertice atual */

  none = none && (!is_art[v]); /* encontrou um ponto de articulacao ou nao */

  return low;
}


int main ( void )
{
  int m,i,a,b,teste=1;
  
  while (scanf("%d%d",&n,&m) && (n || m))
    {
      memset(graph,0,sizeof(graph));
      memset(visited,0,sizeof(visited));
      memset(is_art,0,sizeof(is_art));

      for(i=0;i<m;i++)
	{
	  scanf("%d%d",&a,&b);
	  a--;b--;
	  graph[a][b] = graph[b][a] = 1;
	}

      none = 1;
      dfs(0,0);


      printf("Teste %d\n",teste++);
      if (none)
	printf("nenhum\n\n");
      else
	{
	  for(i=0;i<n;i++)
	    if(is_art[i])
	      printf("%d ",i+1);
	  printf("\n\n");
	}
    }

  return 0;
}





